// TOPSCCC 9188 COMTEST2
#include<stdio.h>
#include<conio.h>
#include "..\lib\9188D.h"

/* ------------------------------------------------------------------- */

void  main()
{
int i,val,t;
int turn,send_com,read_com,data,no_response;
char c;

InstallCom(1,57600L,8,0,1);	/* COM1, RS485 */
InstallCom(2,57600L,8,0,1);	/* COM2, RS485 */

TimerOpen();			/* for DelayMs() */
printf("\nCOM1/COM2 RS485 test");
no_response=0;
  for(turn=0;turn<4;turn++){

    if(turn==0){ 		//set COM2 send data to COM1
	LedOn();
	send_com=2;
	read_com=1;
	data=0x55;
    }else if(turn==1){          //set COM2 send data to COM1
	send_com=2;
	read_com=1;
	data=0xAA;
    }else if(turn==2){          //set COM1 send data to COM2
	LedOff();
	send_com=1;
	read_com=2;
	data=0x55;
    }else if(turn==3){          //set COM1 send data to COM2
	send_com=1;
	read_com=2;
	data=0xAA;
	turn=-1;		//reset the counter
    }

    Set485DirToTransmit(send_com);
    ToCom(send_com,data);
    WaitTransmitOver(send_com);
    Set485DirToReceive(send_com);

    i=0;
    while(IsCom(read_com)==0) 	//wait for data
    {
	  i++;
	  if (i>30000){
		no_response=1;
		break;
	  }
    }

    //read data if there is any
    if(!no_response){
	val=ReadCom(read_com);
	printf("\nCOM%i send %x --> COM%i receive %x",send_com,data,read_com,val);

    }else{
	printf("\nCOM%i send %x --> COM%i no response",send_com,data,read_com);
	no_response=0;
    }

    if (kbhit())		/* PC's key hit from COM4 */
    {
       c=getch();		/* press 'q' to exit 	  */
       if ((c=='q') || (c=='Q'))
	  {
	  RestoreCom(1);
	  RestoreCom(2);
          TimerClose();
	  return;
	  }
    }
    DelayMs(500);
  }

}
