// TOPSCCC 9188 COMTEST2
#include<stdio.h>
#include<conio.h>
#include "..\lib\9188D.h"

/* ------------------------------------------------------------------- */

void  main()
{
 int i,val,t,j,num_data,num_byte;
 int v[60];
 int turn,send_com,read_com,data,no_response;
 char c;

 InstallCom(1,57600L,8,0,1);	/* COM1, RS485 */
 InstallCom(2,57600L,8,0,1);	/* COM2, RS485 */

  printf("\nCOM1/COM2 RS485 test with multiple bytes of data\n");

    printf("How many bytes of data to send from COM1 to COM2:");
    scanf("%i",&num_byte);

    no_response=0;

    send_com=1;
    read_com=2;
    data = 0x00;	//data is initialized

    Set485DirToTransmit(send_com);
    for(i=0;i<num_byte;i++){	//send num_byte bytes
	ToCom(send_com,data);
	WaitTransmitOver(send_com);
	data++;
    }

    Set485DirToReceive(send_com);

    i=0;

    while(IsCom(read_com)==0) 	//wait for data
    {
	  i++;
	  if (i>30000){
		no_response=1;
		break;
	  }
    }

    //read data if there is any
    if(!no_response){
	num_data=0;
	//read all the data in the COM port buffer
	while(IsCom(read_com)==1){
		v[num_data]=ReadCom(read_com);
		num_data++;
	}
	printf("data read from COM2:\n");

	for(j=0;j<num_data;j++)
		printf("%x ",v[j]);

	printf("\n");

    }else{
	printf("\nCOM%i send %x --> COM%i no response",send_com,data,read_com);
	no_response=0;
    }

    RestoreCom(1);
    RestoreCom(2);
    return;

}
