// TOPSCCC 9188 COMTEST1
#include<stdio.h>
#include<conio.h>
#include "..\lib\9188d.h"

/* ------------------------------------------------------------------- */

void  main()
{
int i,val,t;
int send_com, read_com,data;
int no_response, turn;
char c;

InstallCom(1,57600L,8,0,1);	/* COM1, RS-232 */
InstallCom(3,57600L,8,0,1);	/* COM3, RS-232 */

TimerOpen();			/*for DelayMs() */

DelayMs(500);   		/* Delay */
printf("\nCOM3/COM1 RS-232 test");
no_response=0;

  for(turn=0;turn<4;turn++){

    if(turn==0){ 		//set COM3 send data to COM1
	LedOn();
	send_com=3;
	read_com=1;
	data=0x55;
    }else if(turn==1){          //set COM3 send data to COM1
	send_com=3;
	read_com=1;
	data=0xAA;
    }else if(turn==2){          //set COM1 send data to COM3
	LedOff();
	send_com=1;
	read_com=3;
	data=0x55;

    }else if(turn==3){          //set COM1 send data to COM3
	send_com=1;
	read_com=3;
	data=0xAA;
	turn=-1;		//reset the counter
    }

    ToCom(send_com,data);       //send data
    i=0;
    while(IsCom(read_com)==0) 	//wait for data
    {
	  i++;
	  if (i>30000){
		no_response=1;
		break;
	  }
    }

    //read data if there is any
    if(!no_response){
	val=ReadCom(read_com);
	printf("\nCOM%i send %x --> COM%i receive %x",send_com,data,read_com,val);

    }else{
	printf("\nCOM%i send %x --> COM%i no response",send_com,data,read_com);
	no_response=0;
    }

    if (kbhit())		/* PC's key hit from COM4 */
    {
       c=getch();		/* press 'q' to exit 	  */
       if ((c=='q') || (c=='Q'))
	  {
	  RestoreCom(1);
	  RestoreCom(3);
	  TimerClose();
	  return;
	  }
    }
    DelayMs(500);
  }
}
